#
# Standard GNU Make non-recursive prologue. Pushes callers $(d) onto a stack,
# for re-entrant Rules.mk processing.
#
sp		:= $(sp).x
dirstack_$(sp)	:= $(d)
d		:= $(dir)


#
# Include source rules
#
dir	:= $(d)/src
include $(dir)/Rules.mk


#
# Include ASN.1 rules
#
dir	:= $(d)/asn1
include $(dir)/Rules.mk


#
# Include bin/ rules
#
dir	:= $(d)/bin
include $(dir)/Rules.mk


#
# Include Zoned Perl module rules
#
dir	:= $(d)/Zoned
include $(dir)/Rules.mk


#
# Include regress rules
#
#dir	:= $(d)/regress
#include $(dir)/Rules.mk


#
# Standard GNU Make non-recursive epilogue. Restores callers $(d), for
# re-entrant Rules.mk processing.
#
d	:= $(dirstack_$(sp))
sp	:= $(basename $(sp))
