#
# Standard GNU Make non-recursive prologue. Pushes callers $(d) onto a stack,
# for re-entrant Rules.mk processing.
#
sp		:= $(sp).x
dirstack_$(sp)	:= $(d)
d		:= $(dir)


# Our parent directory
$(d)/..		:= $(abspath $(d)/..)


#
# Build plan
#
$(d)/Makefile: $(d)/Makefile.PL
	cd $(@D) && perl $(<F) PREFIX="$(prefix)"
	@touch $<

$(d)/blib/lib/Zoned.pm: $(d)/Makefile $(d)/lib/Zoned.pm
	$(MAKE) -C $(abspath $(<D)/..)

$(d)/blib/arch/auto/Zoned/Zoned.so: $(d)/Makefile $(d)/Zoned.xs
	$(MAKE) -C $(<D)

$(d)/.installed: $(d)/blib/lib/Zoned.pm $(d)/blib/arch/auto/Zoned/Zoned.so
	$(MAKE) -C $(@D) install DESTDIR="$(DESTDIR)"
	@touch $@

$(d)/uninstall:
	@rm -f $(@D)/.installed
	if [ -f $(@D)/Makefile ]; then $(MAKE) -C $(@D) uninstall; fi

$(d)/clean:
	@rm -f $(@D)/.installed
	if [ -f $(@D)/Makefile ]; then $(MAKE) -C $(@D) realclean; fi


#
# Mnemonic targets
#
.PHONY: $(d)/uninstall $(d)/clean

install: $(d)/.installed
uninstall: $(d)/uninstall
clean: $(d)/clean


#
# Standard GNU Make non-recursive epilogue. Restores callers $(d), for
# re-entrant Rules.mk processing.
#
d	:= $(dirstack_$(sp))
sp	:= $(basename $(sp))
