#
# Standard GNU Make non-recursive prologue. Pushes callers $(d) onto a stack,
# for re-entrant Rules.mk processing.
#
sp		:= $(sp).x
dirstack_$(sp)	:= $(d)
d		:= $(dir)


SRCS_$(d)	:= $(filter-out $(d)/converter-sample.c, $(wildcard $(d)/*.c))
OBJS_$(d)	:= ${SRCS_$(d):.c=.o}

CPPFLAGS_$(d)	:= -I$(d) $(CPPFLAGS)
CFLAGS_$(d)	:= $(CFLAGS)

ANS1C_FLAGS_$(d)	:= -funnamed-unions


ifneq (clean, $(filter-out +%, $(MAKECMDGOALS)))

$(d)/Rules.mk:	$(d)/ZonedMessage.h

endif


$(d)/ZonedMessage.h: $(d)/ZonedMessage.asn1
	cd $(@D) && asn1c $(ANS1C_FLAGS_$(@D)) $<
	touch $@
	$(MAKE) -C $(CURDIR) $(@D)/libasn1.a $(filter +%, $(MAKECMDGOALS))


$(SRCS_$(d)): $(d)/ZonedMessage.h

$(OBJS_$(d)): $(d)/%.o: $(d)/%.c
	$(CC) -c $(CPPFLAGS_$(@D)) $(filter-out -Werror, $(CFLAGS_$(@D))) -o $@ $<

$(d)/libasn1.a: $(OBJS_$(d)) $(d)/ZonedMessage.h
	ar crv $@ $^


all: $(d)/libasn1.a


.PHONY: $(d)/clean

$(d)/clean:
	rm -f $(@D)/*.[ch] $(@D)/*.o $(@D)/libasn1.a $(@D)/Makefile.am.sample

clean: $(d)/clean


#
# Standard GNU Make non-recursive epilogue. Restores callers $(d), for
# re-entrant Rules.mk processing.
#
d	:= $(dirstack_$(sp))
sp	:= $(basename $(sp))

