#
# Standard GNU Make non-recursive prologue. Pushes callers $(d) onto a stack,
# for re-entrant Rules.mk processing.
#
sp		:= $(sp).x
dirstack_$(sp)	:= $(d)
d		:= $(dir)


# Our parent directory
$(d)/..		:= $(abspath $(d)/..)


$(DESTDIR)$(bindir)/zonectl: $(d)/zonectl
	$(INSTALL_PROGRAM) $< $@

$(d)/uninstall:
	rm -f $(DESTDIR)$(bindir)/zonectl

#$(d)/clean:
#	rm -f 


#
# Mnemonic targets
#
.PHONY: $(d)/uninstall $(d)/clean

install: $(DESTDIR)$(bindir)/zonectl
uninstall: $(d)/uninstall
clean: $(d)/clean


#
# Standard GNU Make non-recursive epilogue. Restores callers $(d), for
# re-entrant Rules.mk processing.
#
d	:= $(dirstack_$(sp))
sp	:= $(basename $(sp))
