#
# Standard GNU Make non-recursive prologue. Pushes callers $(d) onto a stack,
# for re-entrant Rules.mk processing.
#
sp		:= $(sp).x
dirstack_$(sp)	:= $(d)
d		:= $(dir)


# Our parent directory
$(d)/..		:= $(abspath $(d)/..)


OBJS_$(d)	:= $(d)/main.o $(d)/options.o $(d)/log.o $(d)/pidfile.o $(d)/version.o $(d)/listen.o $(d)/znode.o $(d)/locate.o $(d)/zmbuf.o $(d)/bdb.o $(d)/edit.o
SRCS_$(d)	:= $(d)/main.c $(d)/options.c $(d)/log.c $(d)/pidfile.c $(d)/version.c $(d)/listen.c $(d)/znode.c $(d)/locate.c $(d)/zmbuf.c $(d)/bdb.c $(d)/edit.c
INCS_$(d)	:=             $(d)/options.h $(d)/log.h $(d)/pidfile.h $(d)/version.h $(d)/listen.h $(d)/znode.h $(d)/locate.h $(d)/zmbuf.h $(d)/bdb.h $(d)/edit.h


CFLAGS_$(d)	:= $(CFLAGS)
CPPFLAGS_$(d)	:= -I$($(d)/..)/libnostd -I$($(d)/..)/libnostd/compat -DHAVE_LIBNOSTD -D_REENTRANT -I$($(d)/..)/asn1 $(CPPFLAGS)

LDFLAGS_$(d)	:= $(LDFLAGS) -L$($(d)/..)/asn1
LIBS_$(d)	:= $(LIBS) -lasn1 -levnet -larena -ldb -lssl -lcrypto -levent -lcares -lpthread


#
# Compilation Targets
#
$(d)/version.c: $(filter-out $(d)/version.o, $(OBJS_$(d)))
	@touch $@

$(OBJS_$(d)): $(d)/%.o: $(d)/%.c $(INCS_$(d))
	$(CC) -c $(CPPFLAGS_$(@D)) $(CFLAGS_$(@D)) -o $@ $<

$(d)/zoned: $(OBJS_$(d)) $($(d)/..)/asn1/libasn1.a
	$(CC) $(CPPFLAGS_$(@D)) $(CFLAGS_$(@D)) $(LDFLAGS_$(@D)) -o $@ $(filter %.o, $^) $(LIBS_$(@D))

all: $(d)/zoned


#
# Install targets
#

#install:


#
# Uninstall targets
#
#.PHONY:

#uninstall:


#
# Clean targets
#
.PHONY: $(d)/clean

$(d)/clean:
	rm -f $(OBJS_$(@D)) $(@D)/zoned

clean: $(d)/clean


#
# Standard GNU Make non-recursive epilogue. Restores callers $(d), for
# re-entrant Rules.mk processing.
#
d	:= $(dirstack_$(sp))
sp	:= $(basename $(sp))
