/* ==========================================================================
 * Zoned - BIND DLZ Replicator
 * --------------------------------------------------------------------------
 * Copyright (C) 2007  William Ahern
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * ==========================================================================
 */
#ifndef BDB_H
#define BDB_H

#include <signal.h>	/* sig_atomic_t */

#include <db.h>


#define BDB_SELF_EID	1


enum bdb_event {
	BDB_EV_BOTHER,
	BDB_EV_NODE_JOIN,
	BDB_EV_NODE_GONE,
}; /* bdb_event */


struct bdb {
	struct {
		DB_ENV *env;
		DB *data, *xfr, *zone, *client;
	} db;

	struct {
		int is_self;
		sig_atomic_t envid;
	} master;
}; /* struct bdb */


extern struct bdb DNSDB;


struct zmbuf;

void zmbuf_recv(struct zmbuf *, int);

void bdb_openall(struct bdb *, int);

void bdb_wakeup(enum bdb_event);

void bdb_init(void);


#endif /* BDB_H */
