/* ==========================================================================
 * Zoned - BIND DLZ Replicator
 * --------------------------------------------------------------------------
 * Copyright (C) 2007  William Ahern
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * ==========================================================================
 */
#include <errno.h>	/* errno */


#ifndef SYSERR_MAX
#define SYSERR_MAX	8
#endif


static int syserr_op(int op, int e) {
	static int stack[SYSERR_MAX];
	static int depth;

	switch (op) {
	case 0:
		return errno = stack[depth++] = e;
	case 1:
		return errno = stack[--depth];
	case 2:
		return depth = 0;
	case 3:
		return depth;
	}

	return 0;
} /* syserr_op() */


#define syserr_push(e)	syserr_op(0, e)
#define syserr_pop()	syserr_op(1, 0)
#define syserr_clear()	syserr_op(2, 0)
#define syserr_count()	syserr_op(3, 0)

