/* ==========================================================================
 * Zoned - BIND DLZ Replicator
 * --------------------------------------------------------------------------
 * Copyright (C) 2007  William Ahern
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * ==========================================================================
 */
#include <stdio.h>

/* Mmm dd yyyy
 * 0123456789A
 */
#define DATE_YEAR(s)			\
	((1000 * ((s)[0x07] - '0')) +	\
	  (100 * ((s)[0x08] - '0')) +	\
	   (10 * ((s)[0x09] - '0')) +	\
	    (1 * ((s)[0x0a] - '0')))

#define DATE_DAY(s)			\
	((((s)[4] == ' ')? 0 : 10 * ((s)[4] - '0'))  +  (s)[5] - '0')

#define DATE_MONTH(s)						\
	( (s)[0] == 'J' && (s)[1] == 'a' && (s)[2] == 'n' ? 1	\
	: (s)[0] == 'F' && (s)[1] == 'e' && (s)[2] == 'b' ? 2	\
	: (s)[0] == 'M' && (s)[1] == 'a' && (s)[2] == 'r' ? 3	\
	: (s)[0] == 'A' && (s)[1] == 'p' && (s)[2] == 'r' ? 4	\
	: (s)[0] == 'M' && (s)[1] == 'a' && (s)[2] == 'y' ? 5	\
	: (s)[0] == 'J' && (s)[1] == 'u' && (s)[2] == 'n' ? 6	\
	: (s)[0] == 'J' && (s)[1] == 'u' && (s)[2] == 'l' ? 7	\
	: (s)[0] == 'A' && (s)[1] == 'u' && (s)[2] == 'g' ? 8	\
	: (s)[0] == 'S' && (s)[1] == 'e' && (s)[2] == 'p' ? 9	\
	: (s)[0] == 'O' && (s)[1] == 'c' && (s)[2] == 't' ? 10	\
	: (s)[0] == 'N' && (s)[1] == 'o' && (s)[2] == 'v' ? 11	\
	: (s)[0] == 'D' && (s)[1] == 'e' && (s)[2] == 'c' ? 12	\
	: 0)

/* HH:MM:SS
 * 01234567
 */
#define TIME_HOUR(s)	((10 * ((s)[0] - '0')) + ((s)[1] - '0'))

#define TIME_MINUTE(s)	((10 * ((s)[3] - '0')) + ((s)[4] - '0'))

#define TIME_SECOND(s)	((10 * ((s)[6] - '0')) + ((s)[7] - '0'))


const char *version_pretty(void) {
	static char strbuf[64];

	(void)snprintf(strbuf, sizeof strbuf, "%.4d-%.2d-%.2dT%.2d:%.2d:%.2d",
		DATE_YEAR(__DATE__), DATE_MONTH(__DATE__), DATE_DAY(__DATE__),
		TIME_HOUR(__TIME__), TIME_MINUTE(__TIME__), TIME_SECOND(__TIME__));

	return strbuf;
} /* version_pretty() */

