/* ==========================================================================
 * Zoned - BIND DLZ Replicator
 * --------------------------------------------------------------------------
 * Copyright (C) 2007  William Ahern
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * ==========================================================================
 */
#ifndef ZNODE_H
#define ZNODE_H

#include <stdint.h>	/* uint32_t */


struct znode;
struct zmbuf;
struct socket;

extern struct znode *zself;

int znode_count_byenvid(void);
int znode_count_byhost(void);

struct znode *znode_find_byhost(const char *, unsigned short);
struct znode *znode_find_byenvid(int);

void znode_send(struct znode *, struct zmbuf *);

int zmbuf_send(struct zmbuf *, int, uint32_t);

struct znode *znode_open(struct socket *);

void znode_close(struct znode *);

void znode_refinc(struct znode *);
void znode_refdec(struct znode *);

const char *znode_label(struct znode *);

void znode_start(struct znode *);

void znode_init(void);


#endif /* ZNODE_H */
